﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class GameManager : MonoBehaviour {

    public Text ClickCount;                 // UI element in scene under Canvas.

    public GameObject ClickButton;               // Gameobject in scene under Canvas.

    public bool UseRefillTimer;             // Toggle in Inspector if used or not.

    public GameObject scaleRefillBar;        // Gameobject in scene under Canvas > Timer shows refill progress.

    public float timeToRefill = 5;          

    private int clickTotal;

    private float refillValue;                // counter used to refill bar progress.

    private bool refilling;

    void Start()
    {
        // Activate button but once clicked disable until refilled.
        ClickButton.SetActive(true);

        if (!UseRefillTimer)
        {
            scaleRefillBar.SetActive(false);
        }
    }

    private void Update()
    {
        if (refilling)
        {
            refillValue += Time.deltaTime;
            scaleRefillBar.transform.localScale = new Vector3(refillValue/timeToRefill, 1, 1);

            // Ir bar full is full, reactivate button.
            if (refillValue >= timeToRefill)
            {
                refilling = false;
                ClickButton.GetComponent<Button>().interactable = true;
            }
        }
    }
    // Fired from UI button.
    public void Clicked()
    {
        // Increment and update UI.
        clickTotal++;
        ClickCount.text = string.Format("#CLICKS: {0}", clickTotal);

        // If refilling activated then reset and trigger it.
        if (UseRefillTimer)
        {
            // Disable button until refill finished.
            ClickButton.GetComponent<Button>().interactable = false;

            refillValue = 0;
            refilling = true;
        }
    }
}
